Index: /main/trunk/greenstone2/common-src/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/Makefile.in	(revision 27329)
+++ /main/trunk/greenstone2/common-src/Makefile.in	(revision 27330)
@@ -106,6 +106,6 @@
 	  (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
 	done
-	if test -e $(INDEXERSDIR)/lucene-gs/LuceneWrapper.jar; then \
-	  cp $(INDEXERSDIR)/lucene-gs/LuceneWrapper.jar ../bin/java/.; \
+	if test -e $(INDEXERSDIR)/lucene-gs/LuceneWrapper3.jar; then \
+	  cp $(INDEXERSDIR)/lucene-gs/LuceneWrapper3.jar ../bin/java/.; \
 	fi
 	for idir in $(INSTALLDIRS); do \
@@ -119,6 +119,6 @@
 	  (cd $$odir && $(MAKE) $(MDEFINES) $@) || exit 1; \
 	done
-	if test -e $(INDEXERSDIR)/lucene-gs/LuceneWrapper.jar; then \
-	  cp $(INDEXERSDIR)/lucene-gs/LuceneWrapper.jar ../bin/java/.; \
+	if test -e $(INDEXERSDIR)/lucene-gs/LuceneWrapper3.jar; then \
+	  cp $(INDEXERSDIR)/lucene-gs/LuceneWrapper3.jar ../bin/java/.; \
 	fi
 	for odir in $(COMPILEDIRS) $(MODULEDIRS); do \
Index: /main/trunk/greenstone2/common-src/indexers/lucene-gs/Makefile.in
===================================================================
--- /main/trunk/greenstone2/common-src/indexers/lucene-gs/Makefile.in	(revision 27329)
+++ /main/trunk/greenstone2/common-src/indexers/lucene-gs/Makefile.in	(revision 27330)
@@ -3,16 +3,5 @@
 JAR = jar
 
-LUCENE_JAR = ./lib/lucene-core-2.3.2.jar
 LUCENE3_JAR = ./lib/lucene-core-3.3.0.jar
-
-
-LUCENE_WRAPPER_OBJECTS = \
-	classes/org/greenstone/LuceneWrapper/GS2Analyzer.class \
-	classes/org/greenstone/LuceneWrapper/GS2IndexModifier.class \
-	classes/org/greenstone/LuceneWrapper/GS2LuceneDelete.class \
-	classes/org/greenstone/LuceneWrapper/GS2LuceneEditor.class \
-	classes/org/greenstone/LuceneWrapper/GS2LuceneIndexer.class \
-	classes/org/greenstone/LuceneWrapper/GS2LuceneQuery.class \
-	classes/org/greenstone/LuceneWrapper/LuceneQueryResult.class
 
 LUCENE3_WRAPPER_OBJECTS = \
@@ -27,11 +16,5 @@
 	classes3/org/greenstone/LuceneWrapper3/SharedSoleneQueryResult.class
 
-LUCENE_WRAPPER_JAR = LuceneWrapper.jar
-
 LUCENE3_WRAPPER_JAR = LuceneWrapper3.jar
-
-
-classes/org/greenstone/LuceneWrapper/%.class: src/org/greenstone/LuceneWrapper/%.java
-	mkdir -p classes && $(JAVAC) $(JAVACFLAGS) -classpath $(LUCENE_JAR):classes:. -d classes -sourcepath src/ src/org/greenstone/LuceneWrapper/$*.java
 
 # For now, drop using JAVACFLAGS in compile line, as it typically sets
@@ -40,23 +23,15 @@
 	mkdir -p classes3 && $(JAVAC) -classpath $(LUCENE3_JAR):classes3:. -d classes3 -sourcepath src/ src/org/greenstone/LuceneWrapper3/$*.java
 
-LuceneWrapper.jar: $(LUCENE_WRAPPER_OBJECTS)
-	cd classes && jar xf ../$(LUCENE_JAR)
-	$(JAR) cf $(LUCENE_WRAPPER_JAR) -C classes .
-
 LuceneWrapper3.jar: $(LUCENE3_WRAPPER_OBJECTS)
 	cd classes3 && jar xf ../$(LUCENE3_JAR)
 	$(JAR) cf $(LUCENE3_WRAPPER_JAR) -C classes3 .
 
-all: $(LUCENE_WRAPPER_JAR) $(LUCENE3_WRAPPER_JAR)
-
+all: $(LUCENE3_WRAPPER_JAR)
 install: all
 
 clean:
-	/bin/rm -f $(LUCENE_WRAPPER_OBJECTS) $(LUCENE_WRAPPER_JAR)
 	/bin/rm -f $(LUCENE3_WRAPPER_OBJECTS) $(LUCENE3_WRAPPER_JAR)
 
 distclean: clean
-	if test -e classes; then /bin/rm -r classes; fi
-	if test -e $(LUCENE_WRAPPER_JAR); then /bin/rm -r $(LUCENE_WRAPPER_JAR); fi
 	if test -e classes3; then /bin/rm -r classes3; fi
 	if test -e $(LUCENE3_WRAPPER_JAR); then /bin/rm -r $(LUCENE3_WRAPPER_JAR); fi
Index: /main/trunk/greenstone2/common-src/indexers/lucene-gs/winMake.bat
===================================================================
--- /main/trunk/greenstone2/common-src/indexers/lucene-gs/winMake.bat	(revision 27329)
+++ /main/trunk/greenstone2/common-src/indexers/lucene-gs/winMake.bat	(revision 27330)
@@ -4,5 +4,4 @@
 
 rem ---- Where to put class files ----
-set JAVACLASSDIR=classes
 set JAVACLASSDIR3=classes3
 
@@ -15,7 +14,4 @@
 
 set JAVACOPTIONS=-deprecation -g -O
-
-set LUCENE_JAR=.\lib\lucene-core-2.3.2.jar
-set MYCLASSPATH=%LUCENE_JAR%;%JAVACLASSDIR%
 
 set LUCENE3_JAR=.\lib\lucene-core-3.3.0.jar
@@ -38,12 +34,4 @@
 
 :all
-	if not exist %JAVACLASSDIR% mkdir %JAVACLASSDIR%
-	echo Compiling Greenstone Lucene version 2.x Java classes ...
-	%JAVAC% -d %JAVACLASSDIR% -classpath %MYCLASSPATH% %JAVACOPTIONS% -sourcepath src src\org\greenstone\LuceneWrapper\*.java
-	cd %JAVACLASSDIR%
-	%JAR% xf ..\%LUCENE_JAR%
-	cd ..
-	%JAR% cf LuceneWrapper.jar -C %JAVACLASSDIR% .
-
 	if not exist %JAVACLASSDIR3% mkdir %JAVACLASSDIR3%
 	echo Compiling Greenstone Lucene version 3.x Java classes ...
@@ -60,6 +48,4 @@
 :clean
 	echo Cleaning up Greenstone Lucene ...
-	if exist %JAVACLASSDIR% rmdir /S /Q %JAVACLASSDIR%
-        if exist LuceneWrapper.jar del LuceneWrapper.jar
 	if exist %JAVACLASSDIR3% rmdir /S /Q %JAVACLASSDIR3%
         if exist LuceneWrapper3.jar del LuceneWrapper3.jar
Index: /main/trunk/greenstone2/common-src/win32.mak
===================================================================
--- /main/trunk/greenstone2/common-src/win32.mak	(revision 27329)
+++ /main/trunk/greenstone2/common-src/win32.mak	(revision 27330)
@@ -286,6 +286,6 @@
 	for %%i in (bin\*.exe) do \
 	  if exist %%i copy %%i "$(GSDLHOME)\bin\windows"
-	if EXIST "lucene-gs\LuceneWrapper.jar" copy "lucene-gs\LuceneWrapper.jar" "$(GSDLHOME)\bin\java"
-	@if NOT EXIST "lucene-gs\LuceneWrapper.jar" echo Warning: Failed to find lucene-gs\LuceneWrapper.jar. Greenstone will not be able to use Lucene for indexing
+	if EXIST "lucene-gs\LuceneWrapper3.jar" copy "lucene-gs\LuceneWrapper3.jar" "$(GSDLHOME)\bin\java"
+	@if NOT EXIST "lucene-gs\LuceneWrapper3.jar" echo Warning: Failed to find lucene-gs\LuceneWrapper3.jar. Greenstone will not be able to use Lucene for indexing
 	cd "$(GSDLHOME)"
 