Index: gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE.sh	(revision 27447)
+++ gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE.sh	(revision 27448)
@@ -1,5 +1,5 @@
 #!/bin/bash
 
-list="OPENMPI TINYXML IPCRUN PROCDAEMON SORTKEY BITVECTOR THRIFT TESTFATAL MODULEBUILD DATETIME"
+list="OPENMPI TINYXML IPCRUN PROCDAEMON SORTKEY BITVECTOR THRIFT VERSION PERLOSTYPE MODULEMETADATA MODULEBUILD TESTFATAL DATETIME"
 
 for d in $list ; do
Index: gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEMETADATA.sh
===================================================================
--- gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEMETADATA.sh	(revision 27448)
+++ gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEMETADATA.sh	(revision 27448)
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+package=Module-Metadata
+version=-1.000014
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
+
+prefix=$GEXTPARALLELBUILDING_INSTALLED
+perlversion=$PERL_VERSION
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
+
+# We only compile if necessary, as compilation is quite slow and we don't
+# edit these source files
+if [[ ! -e "$prefix/lib/perl/$perlversion/Module/Metadata.pm" ]]
+then
+  opt_run_make $compile   $package $version
+  echo "opt_run_make $install $package $version \"install\""
+  opt_run_make $install   $package $version "install"
+else
+  echo "Module::Metadata Perl module already compiled => no need to recompile"
+fi
+
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
+
+
+
+
Index: gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PERLOSTYPE.sh
===================================================================
--- gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PERLOSTYPE.sh	(revision 27448)
+++ gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PERLOSTYPE.sh	(revision 27448)
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+package=Perl-OSType
+version=-1.003
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
+
+prefix=$GEXTPARALLELBUILDING_INSTALLED
+perlversion=$PERL_VERSION
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
+
+# We only compile if necessary, as compilation is quite slow and we don't
+# edit these source files
+if [[ ! -e "$prefix/lib/perl/$perlversion/Perl/OSType.pm" ]]
+then
+  opt_run_make $compile   $package $version
+  echo "opt_run_make $install $package $version \"install\""
+  opt_run_make $install   $package $version "install"
+else
+  echo "Perl::OSType Perl module already compiled => no need to recompile"
+fi
+
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
+
+
+
+
Index: gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/VERSION.sh
===================================================================
--- gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/VERSION.sh	(revision 27448)
+++ gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/VERSION.sh	(revision 27448)
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+package=version
+version=-0.9902
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
+
+prefix=$GEXTPARALLELBUILDING_INSTALLED
+perlversion=$PERL_VERSION
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
+
+# We only compile if necessary, as compilation is quite slow and we don't
+# edit these source files
+if [[ ! -e "$prefix/lib/perl/$perlversion/version.pm" ]]
+then
+  opt_run_make $compile   $package $version
+  echo "opt_run_make $install $package $version \"install\""
+  opt_run_make $install   $package $version "install"
+else
+  echo "version Perl module already compiled => no need to recompile"
+fi
+
+opt_run_make $clean     $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
+
+
+
+
+
+