Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/BITVECTOR.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/BITVECTOR.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Bit-Vector
-version=-7.2
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Bit/Vector.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Bit::Vector Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/DATETIME.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/DATETIME.sh	(revision 27467)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/bash
-
-package=DateTime
-version=-1.03
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-source ../cascade-make/lib/cascade-lib-modulebuild.bash GEXTPARALLELBUILDING $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_modulebuild_configure $force_config $auto_config $package $version $prefix $perlversion
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/DateTime.pm" ]]
-then
-  opt_modulebuild_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_modulebuild_make $install   $package $version "install"
-else
-  echo "DateTime Perl module already compiled => no need to recompile"
-fi
-
-opt_modulebuild_make $clean     $package $version "clean"
-opt_modulebuild_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEBUILD.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEBUILD.sh	(revision 27467)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/bash
-
-package=Module-Build
-version=-0.4005
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-source ../cascade-make/lib/cascade-lib-modulebuild.bash GEXTPARALLELBUILDING $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_modulebuild_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Module/Build.pm" ]]
-then
-  opt_modulebuild_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_modulebuild_make $install   $package $version "install"
-else
-  echo "Module::Build Perl module already compiled => no need to recompile"
-fi
-
-opt_modulebuild_make $clean     $package $version "clean"
-opt_modulebuild_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEIMPLEMENTATION.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEIMPLEMENTATION.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Module-Implementation
-version=-0.06
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Module/Implementation.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Module::Implementation Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEMETADATA.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULEMETADATA.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Module-Metadata
-version=-1.000014
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Module/Metadata.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Module::Metadata Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULERUNTIME.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/MODULERUNTIME.sh	(revision 27467)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/bash
-
-package=Module-Runtime
-version=-0.013
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-source ../cascade-make/lib/cascade-lib-modulebuild.bash GEXTPARALLELBUILDING $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_modulebuild_configure $force_config $auto_config $package $version $prefix $perlversion
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Module/Runtime.pm" ]]
-then
-  opt_modulebuild_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_modulebuild_make $install   $package $version "install"
-else
-  echo "Module::Runtime Perl module already compiled => no need to recompile"
-fi
-
-opt_modulebuild_make $clean     $package $version "clean"
-opt_modulebuild_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PARAMSVALIDATE.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PARAMSVALIDATE.sh	(revision 27467)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/bash
-
-package=Params-Validate
-version=-1.07
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-source ../cascade-make/lib/cascade-lib-modulebuild.bash GEXTPARALLELBUILDING $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_modulebuild_configure $force_config $auto_config $package $version $prefix $perlversion
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Params/Validate.pm" ]]
-then
-  opt_modulebuild_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_modulebuild_make $install   $package $version "install"
-else
-  echo "Params::Validate Perl module already compiled => no need to recompile"
-fi
-
-opt_modulebuild_make $clean     $package $version "clean"
-opt_modulebuild_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PERLOSTYPE.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/PERLOSTYPE.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Perl-OSType
-version=-1.003
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Perl/OSType.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Perl::OSType Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTFATAL.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTFATAL.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Test-Fatal
-version=-0.010
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Test/Fatal.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Test::Fatal Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTREQUIRES.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTREQUIRES.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Test-Requires
-version=-0.06
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Test/Requires.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Test::Requires Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTSIMPLE.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TESTSIMPLE.sh	(revision 27467)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#!/bin/bash
-
-# Watch the module name here - it's different!
-package=Test-Simple
-version=-0.98
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Test/More.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Test::More Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TRYTINY.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/TRYTINY.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=Try-Tiny
-version=-0.12
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/Try/Tiny.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "Try::Tiny Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-
Index: 2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/VERSION.sh
===================================================================
--- /gs2-extensions/parallel-building/trunk/src/packages/CASCADE-MAKE/VERSION.sh	(revision 27467)
+++ 	(revision )
@@ -1,37 +1,0 @@
-#!/bin/bash
-
-package=version
-version=-0.9902
-
-progname=$0
-
-source ../cascade-make/lib/cascade-lib.bash GEXTPARALLELBUILDING ../.. $*
-
-prefix=$GEXTPARALLELBUILDING_INSTALLED
-perlversion=$PERL_VERSION
-
-opt_run_untar $force_untar $auto_untar $package $version
-opt_run_perl_configure $force_config $auto_config $package $version $prefix INSTALLSITEARCH="$prefix/lib/perl/$perlversion" INSTALLSITELIB="$prefix/lib/perl/$perlversion"
-
-# We only compile if necessary, as compilation is quite slow and we don't
-# edit these source files
-if [[ ! -e "$prefix/lib/perl/$perlversion/version.pm" ]]
-then
-  opt_run_make $compile   $package $version
-  echo "opt_run_make $install $package $version \"install\""
-  opt_run_make $install   $package $version "install"
-else
-  echo "version Perl module already compiled => no need to recompile"
-fi
-
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
-
-
-
-